Bric::SOAP::Element(3)

NAME
Bric::SOAP::Element - SOAP interface to Bricolage element definitions.

VERSION
$LastChangedRevision$

DATE
$LastChangedDate: 2005-02-27 20:36:56 -0800 (Sun, 27 Feb 2005) $

SYNOPSIS
  use SOAP::Lite;
  import SOAP::Data 'name';

  # setup soap object to login with
  my $soap = new SOAP::Lite
    uri      => 'http://bricolage.sourceforge.net/Bric/SOAP/Auth',
    readable => DEBUG;
  $soap->proxy('http://localhost/soap',
               cookie_jar => HTTP::Cookies->new(ignore_discard => 1));
  # login
  $soap->login(name(username => USER),
               name(password => PASSWORD));

  # set uri for Element module
  $soap->uri('http://bricolage.sourceforge.net/Bric/SOAP/Element');

  # get a list of all elements
  my $element_ids = $soap->list_ids()->result;

DESCRIPTION
This module provides a SOAP interface to manipulating Bricolage elements.

INTERFACE

  Public Class Methods

list_ids
    This method queries the database for matching elements and returns a list of ids. If no elements are found an empty list will be returned.

    This method can accept the following named parameters to specify the search. Some fields support matching and are marked with an (M). The value for these fields will be interpreted as an SQL match expression and will be matched case-insensitively. Other fields must specify an exact string to match. Match fields combine to narrow the search results (via ANDs in an SQL WHERE clause).

    key_name (M)
        The element's key name.

    name (M)
        The element's name.

    description (M)
        The element's description.

    output_channel
        The output channel for the element.

    type
        The element's type.

    top_level
        set to 1 to return only top-level elements

    Throws:

    Exception::AP

    Side Effects: NONE

    Notes: NONE

export
    The export method retrieves a set of elements from the database, serializes them and returns them as a single XML document. See Bric::SOAP for the schema of the returned document.

    Accepted paramters are:

    element_id
        Specifies a single element_id to be retrieved.

    element_ids
        Specifies a list of element_ids. The value for this option should be an array of interger "element_id" elements.

    Throws:

    Exception::AP

    Side Effects: NONE

    Notes: NONE

create
    The create method creates new objects using the data contained in an XML document of the format created by export().

    Returns a list of new ids created in the order of the assets in the document.

    Available options:

    document (required)
        The XML document containing objects to be created. The document must contain at least one element object.

    Throws:

    Exception::AP

    Side Effects: NONE

    Notes: You cannot directly set the top_level setting. This value is ignored on update and create; instead it is taken from the type setting.

update
    The update method updates element using the data in an XML document of the format created by export(). A common use of update() is to export() a selected element object, make changes to one or more fields and then submit the changes with update().

    Returns a list of new ids created in the order of the assets in the document.

    Takes the following options:

    document (required)
        The XML document where the objects to be updated can be found. The document must contain at least one element and may contain any number of related element objects.

    update_ids (required)
        A list of "element_id" integers for the assets to be updated. These must match id attributes on element elements in the document. If you include objects in the document that are not listed in update_ids then they will be treated as in create(). For that reason an update() with an empty update_ids list is equivalent to a create().

    Throws:

    Exception::AP

    Side Effects: NONE

    Notes: You cannot directly update the top_level setting. This value is ignored on update and create; instead it is taken from the type setting.

delete
    The delete() method deletes elements. It takes the following options:

    element_id
        Specifies a single element_id to be deleted.

    element_ids
        Specifies a list of element_ids to delete.

    Throws:

    Exception::AP

    Side Effects: NONE

    Notes: NONE

$self->module
    Returns the module name, that is the first argument passed to bric_soap.

is_allowed_param
$pkg->is_allowed_param($param, $method)
    Returns true if $param is an allowed parameter to the $method method.

  Private Class Methods

$pkg->load_asset($args)
    This method provides the meat of both create() and update(). The only difference between the two methods is that update_ids will be empty on create().

$pkg->serialize_asset(writer => $writer, element_id => $element_id, args => $args)
    Serializes a single element object into a <element> element using the given writer and args.

AUTHOR
Sam Tregar <stregar@about-inc.com>

SEE ALSO
Bric::SOAP